#include <GuiConstantsEx.au3>
#include <WindowsConstants.au3>

#include <StringSize.au3>

#include "GUIListViewEx_Mod.au3"

#include <Array.au3> ; Just for display in example

Opt("GUICloseOnESC", 0)

Global $iCount_Left = 20, $iCount_Right = 20, $vData, $sMsg, $aLV_List_Left, $aLV_List_Right, $aRet, $iEditMode = 0

Global $sSeparator = "-------------"

; Create GUI
$hGUI = GUICreate("LVEx Example 1", 640, 510)

; Create Left ListView
GUICtrlCreateLabel("Native ListView" & @CRLF & "Multiple selection - no count - sort && editable (0 && 2)", 10, 5, 300, 30)

$cListView_Left = GUICtrlCreateListView("Tom|Dick|Harry", 10, 40, 300, 300, $LVS_SHOWSELALWAYS)
_GUICtrlListView_SetExtendedListViewStyle($cListView_Left, $LVS_EX_FULLROWSELECT)
_GUICtrlListView_SetColumnWidth($cListView_Left, 0, 93)
_GUICtrlListView_SetColumnWidth($cListView_Left, 1, 93)
_GUICtrlListView_SetColumnWidth($cListView_Left, 2, 93)

GUICtrlSetBkColor($cListView_Left, $GUI_BKCOLOR_LV_ALTERNATE)

; Set font
GUICtrlSetFont($cListView_Left, 12, Default, Default, "Courier New") ; Note edit control will use same font

; Create array and fill Left listview
Global $aLV_List_Left[$iCount_Left]
For $i = 0 To UBound($aLV_List_Left) - 1
	If Mod($i, 5) Then
		$aLV_List_Left[$i] = "Tom " & $i & "|Dick " & $i & "|Harry " & $i
	Else
		$aLV_List_Left[$i] = "Tom " & $i & "||Harry longer " & $i
	EndIf
	GUICtrlCreateListViewItem($aLV_List_Left[$i], $cListView_Left)
	GUICtrlSetBkColor(-1, 0xCCFFCC)
Next

; Initiate LVEx - use filling array - no count parameter - default insert mark colour (black) - drag image - sort & editable - only cols 0 & 2 (plus headers) editable
$iLV_Left_Index = _GUIListViewEx_Init($cListView_Left, $aLV_List_Left, 0, 0, True, 1 + 2 + 8, "0;2")

; Create an array of combo data with separators
Local $aCombo_Data[100] = ["Very long item to test the dropped width code 0"]
For $i = 1 To 99
	If Mod($i, 10) Then
		$aCombo_Data[$i] = "Very long item to test the dropped width code " & $i
	Else
		$aCombo_Data[$i] = $sSeparator
	EndIf
Next

; Determine max width of the combo items
$iWidth = 0
For $i = 0 To 99
	$aSize = _StringSize($aCombo_Data[$i], 12, Default, Default, "Courier New")
	If $aSize[2] > $iWidth Then $iWidth = $aSize[2]
Next

; Use new parameter to set combo dropped width with allowance for slider width
_GUIListViewEx_ComboData($iLV_Left_Index, 2, $aCombo_Data, True, $iWidth + 20)

$cExit_Button = GUICtrlCreateButton("Exit", 430, 390, 200, 110)

GUISetState()

; Register for sorting, dragging and editing
_GUIListViewEx_MsgRegister()

; Show tooltips for column 2
_GUIListViewEx_ToolTipInit($iLV_Left_Index, "2", 2000) ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

While 1
	Switch GUIGetMsg()
		Case $GUI_EVENT_CLOSE, $cExit_Button
			Exit
	EndSwitch

	$aRet = _GUIListViewEx_EditOnClick(0)
	; Array only returned AFTER EditOnClick process - so check array exists
	If IsArray($aRet) Then
		; Check if separator selected
		If $aRet[1][3] = $sSeparator Then
			; Reset the previous value
			_GUIListViewEx_ChangeItem($iLV_Left_Index, $aRet[1][0], $aRet[1][1], $aRet[1][2])
		EndIf
	EndIf

	; Display tooltips when initiated column clicked
	_GUIListViewEx_ToolTipShow() ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<



WEnd

